package dev.shadowsoffire.apotheosis.ench.compat;

import snownee.jade.api.Accessor;
import java.util.Optional;
import net.minecraft.world.item.EnchantedBookItem;
import java.util.List;
import snownee.jade.api.ui.IDisplayHelper;
import net.minecraft.network.chat.Component;
import java.util.ArrayList;
import net.minecraft.network.chat.CommonComponents;
import net.minecraft.world.phys.Vec2;
import net.minecraft.world.level.block.ChiseledBookShelfBlock;
import net.minecraft.world.level.block.state.properties.Property;
import net.minecraft.world.level.block.HorizontalDirectionalBlock;
import net.minecraft.core.Direction;
import net.minecraft.world.phys.BlockHitResult;
import dev.shadowsoffire.apotheosis.ench.objects.FilteringShelfBlock;
import net.minecraft.resources.ResourceLocation;
import snownee.jade.api.ui.IElementHelper;
import snownee.jade.api.ui.IElement;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.nbt.Tag;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Items;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.Level;
import java.util.Iterator;
import net.minecraft.nbt.CompoundTag;
import dev.shadowsoffire.apotheosis.ench.Ench;
import snownee.jade.api.Identifiers;
import net.minecraft.world.level.block.Blocks;
import java.util.function.Consumer;
import dev.shadowsoffire.apotheosis.util.CommonTooltipUtil;
import java.util.Objects;
import net.minecraft.world.item.enchantment.Enchantment;
import java.util.Map;
import net.minecraft.world.item.enchantment.EnchantmentHelper;
import dev.shadowsoffire.apotheosis.ench.anvil.ApothAnvilBlock;
import snownee.jade.api.config.IPluginConfig;
import snownee.jade.api.ITooltip;
import net.minecraft.world.level.block.Block;
import snownee.jade.api.IWailaClientRegistration;
import dev.shadowsoffire.apotheosis.ench.anvil.AnvilTile;
import dev.shadowsoffire.apotheosis.Apotheosis;
import snownee.jade.api.IWailaCommonRegistration;
import snownee.jade.api.WailaPlugin;
import snownee.jade.api.BlockAccessor;
import snownee.jade.api.IServerDataProvider;
import snownee.jade.api.IBlockComponentProvider;
import snownee.jade.api.IWailaPlugin;

@WailaPlugin
public class EnchHwylaPlugin implements IWailaPlugin, IBlockComponentProvider, IServerDataProvider<BlockAccessor>
{
    public void register(final IWailaCommonRegistration reg) {
        if (Apotheosis.enableEnch) {
            reg.registerBlockDataProvider((IServerDataProvider)this, (Class)AnvilTile.class);
        }
    }
    
    public void registerClient(final IWailaClientRegistration reg) {
        if (Apotheosis.enableEnch) {
            reg.registerBlockComponent((IBlockComponentProvider)this, (Class)Block.class);
        }
    }
    
    public void appendTooltip(final ITooltip tooltip, final BlockAccessor accessor, final IPluginConfig config) {
        if (accessor.getBlock() instanceof ApothAnvilBlock) {
            final CompoundTag tag = accessor.getServerData();
            final Map<Enchantment, Integer> enchants = EnchantmentHelper.m_44882_(tag.m_128437_("enchantments", 10));
            for (final Map.Entry<Enchantment, Integer> e : enchants.entrySet()) {
                tooltip.add(e.getKey().m_44700_((int)e.getValue()));
            }
        }
        final Level level = accessor.getLevel();
        final BlockState blockState = accessor.getBlockState();
        final BlockPos position = accessor.getPosition();
        Objects.requireNonNull(tooltip);
        CommonTooltipUtil.appendBlockStats(level, blockState, position, (Consumer)tooltip::add);
        if (accessor.getBlock() == Blocks.f_50201_) {
            final Level level2 = accessor.getLevel();
            final BlockPos position2 = accessor.getPosition();
            Objects.requireNonNull(tooltip);
            CommonTooltipUtil.appendTableStats(level2, position2, (Consumer)tooltip::add);
            tooltip.remove(Identifiers.MC_TOTAL_ENCHANTMENT_POWER);
        }
        if (accessor.getBlock() == Ench.Blocks.FILTERING_SHELF.get()) {
            this.handleFilteringShelf(tooltip, accessor);
        }
    }
    
    public void appendServerData(final CompoundTag tag, final BlockAccessor access) {
        final BlockEntity blockEntity = access.getBlockEntity();
        if (blockEntity instanceof final AnvilTile te) {
            final ItemStack stack = new ItemStack((ItemLike)Items.f_42146_);
            EnchantmentHelper.m_44865_((Map)te.getEnchantments(), stack);
            tag.m_128365_("enchantments", (Tag)stack.m_41785_());
        }
    }
    
    public IElement getIcon(final BlockAccessor accessor, final IPluginConfig config, final IElement currentIcon) {
        if (accessor.getBlock() == Ench.Blocks.FILTERING_SHELF.get()) {
            return IElementHelper.get().item(accessor.getPickedResult());
        }
        return currentIcon;
    }
    
    public ResourceLocation getUid() {
        return Apotheosis.loc("ench");
    }
    
    public int getDefaultPriority() {
        return 1150;
    }
    
    public void handleFilteringShelf(final ITooltip tooltip, final BlockAccessor accessor) {
        tooltip.remove(Identifiers.MC_ENCHANTMENT_POWER);
        tooltip.remove(Identifiers.MC_CHISELED_BOOKSHELF);
        tooltip.remove(Identifiers.UNIVERSAL_ITEM_STORAGE);
        if (accessor.showDetails()) {
            return;
        }
        final BlockEntity blockEntity = accessor.getBlockEntity();
        if (blockEntity instanceof final FilteringShelfBlock.FilteringShelfTile tile) {
            final Optional<Vec2> optional = ChiseledBookShelfBlock.m_260871_((BlockHitResult)accessor.getHitResult(), (Direction)accessor.getBlockState().m_61143_((Property)HorizontalDirectionalBlock.f_54117_));
            if (optional.isEmpty()) {
                return;
            }
            final int slot = ChiseledBookShelfBlock.m_261279_((Vec2)optional.get());
            final ItemStack stack = tile.m_8020_(slot);
            if (stack.m_41619_()) {
                return;
            }
            tooltip.add(CommonComponents.f_237098_);
            final IElementHelper helper = tooltip.getElementHelper();
            final List<IElement> elements = new ArrayList<IElement>();
            elements.add(helper.smallItem(stack).clearCachedMessage());
            elements.add(helper.text((Component)Component.m_237113_(" ").m_7220_((Component)Component.m_237113_(IDisplayHelper.get().humanReadableNumber((double)stack.m_41613_(), "", false)).m_130946_("× ").m_7220_(stack.m_41786_()))).message((String)null));
            tooltip.add((List)elements);
            if (stack.m_41783_() != null && stack.m_41783_().m_128441_("StoredEnchantments")) {
                final List<Component> list = new ArrayList<Component>();
                ItemStack.m_41709_((List)list, EnchantedBookItem.m_41163_(stack));
                for (final Component c : list) {
                    tooltip.add((Component)Component.m_237113_(" - ").m_7220_(c));
                }
            }
        }
    }
}
